IPROP(8)

NAME
iprop, ipropd-master, ipropd-slave - propagate transactions from a Heimdal Kerberos master KDC to slave KDCs

SYNOPSIS
ipropd-master [-c string - -config-file=string] [-r string - -realm=string] [-k kspec - -keytab=kspec] [-d file - -database=file] [- -slave-stats-file=file] [- -time-missing=time] [- -time-gone=time] [- -detach] [- -version] [- -help]
ipropd-slave [-c string - -config-file=string] [-r string - -realm=string] [-d file - -database=file] [-k kspec - -keytab=kspec] [- -no-keytab] [- -cache=cspec] [- -statusfile=file] [- -hostname=hostname] [- -port=port] [- -time-lost=time] [- -async-hdb] [- -detach] [- -version] [- -help] master

DESCRIPTION
ipropd-master is used to propagate changes to a Heimdal Kerberos database from the master Kerberos server on which it runs to slave Kerberos servers running ipropd-slave.

The slaves are specified by the contents of the slaves file in the KDC's database directory, e.g. /var/heimdal/slaves. This has principals one per-line of the form
    iprop/slave@REALM
where slave is the hostname of the slave server in the given REALM, e.g.
    iprop/kerberos-1.example.com@EXAMPLE.COM
On a slave, the argument master specifies the hostname of the master server from which to receive updates.

In contrast to hprop(8), which sends the whole database to the slaves regularly, iprop normally sends only the changes as they happen on the master. The master keeps track of all the changes by assigning a version number to every transaction to the database. The slaves know which was the latest version they saw, and in this way it can be determined if they are in sync or not. A log of all the transactions is kept on the master. When a slave is at an older version than the oldest one in the log, the whole database has to be sent.

The log of transactions is also used to implement a two-phase commit (with roll-forward for recovery) method of updating the HDB. Transactions are first recorded in the log, then in the HDB, then the log is updated to mark the transaction as committed.

The changes are propagated over a secure channel (on port 2121 by default). This should normally be defined as “iprop/tcp” in /etc/services or another source of the services database.

The ipropd-master and ipropd-slave programs require acceptor and initiator credentials, respectively, for host-based principals for the iprop service and the fully-qualified hostnames of the hosts on which they run.

The ipropd-master program uses, by default, the HDB-backed keytab HDBGET:, though a file-based keytab can also be specified.

The ipropd-slave program uses the default keytab, which is specified by the KRB5_KTNAME environment variable, or the value of the default_keytab_name configuration parameter in the [libdefaults] section. However, if the - -no-keytab option is given, then ipropd-slave will use the given or default credentials cache, and it will expect that cache to be kept fresh externally (such as by the kinit program).

There is a keep-alive feature logged in the master's slave-stats file (e.g. /var/heimdal/slave-stats).

Note that hierarchical replication is supported by running an ipropd-master on the same KDC as an ipropd-slave.

Supported options for ipropd-master:

-c string, - -config-file=string

-r string, - -realm=string

-k kspec, - -keytab=kspec
    Keytab for authenticating ipropd-slave clients.

- -cache=cspec
    If the keytab given is the empty string then credentials will be used from the default credentials cache, or from the cspec if given.

-d file, - -database=file
    Database (default per KDC)

- -slave-stats-file=file
    File for slave status information.

- -time-missing=time
    Time before slave is polled for presence (default 2 min).

- -time-gone=time
    Time of inactivity after which a slave is considered gone (default 5 min).

- -detach
    Detach from console.

- -version

- -help

Supported options for ipropd-slave:

-c string, - -config-file=string

-r string, - -realm=string

-d file, - -database=file
    Database (default per KDC)

-k kspec, - -keytab=kspec
    Keytab with client credentials for authenticating to ipropd-master.

- -status-file=file

- -hostname=hostname
    Hostname for client principal if different from actual hostname.

- -port=port

- -time-lost=time
    time before server is considered lost (default 5 min)

- -async-hdb
    Use asynchronous writes. This is very useful for very busy sites or sites with very large HDBs.

- -detach
    Detach from console.

- -version

- -help
Time arguments for the relevant options above may be specified in forms like 5 min, 300 s, or simply a number of seconds.

FILES
slaves, slave-stats in the database directory. ipropd-master.pid, ipropd-slave.pid in the database directory, or in the directory named by the HEIM_PIDFILE_DIR environment variable.

SEE ALSO
kinit(1), krb5.conf(5), hprop(8), hpropd(8), iprop-log(8), kdc(8).